首页 > 其他分享 >Codeforces Round 867 (Div. 3)

Codeforces Round 867 (Div. 3)

时间:2023-05-04 23:45:29浏览次数:43  
标签:std cout int Codeforces 867 cin cnt1 tie Div

A. TubeTube Feed

分析:

从所有a[i]+i-1<=t的选择种取个max即可

code:

#include <bits/stdc++.h>
using namespace std;
 
const int N = 55;
int a[N], b[N];
 
 
int main()
{
    std::ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
	
	int t;
	cin >> t;
	
	while (t --)
	{
		int n, m;
		cin >> n >> m;
		
		for (int i = 0; i < n; i ++)
			cin >> a[i];
			
		for (int i = 0; i < n; i ++)
			cin >> b[i];
			
		int s = 0, res = 0, idx = -1;
		bool flag = false;
		
		for (int i = 0; i < n; i ++)
		{
			if (s + a[i] <= m)
			{
				flag = true;
				if (b[i] > res)
				{
					res = b[i];
					idx = i + 1;
				}
			}
			s ++;	
		}
		
		if (!flag)
			cout << -1 << endl;
		else
			cout << idx << endl;
	}    
	
    return 0;
}

B. Karina and Array

分析:

实际上就是取同符号乘积的最大值

code:

#include <bits/stdc++.h>
using namespace std;
 
const int N = 2e5 + 5;
int a[N], b[N];
 
typedef long long LL;
 
int main()
{
    std::ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
	
	int t;
	cin >> t;
	
	while (t --)
	{
		int n;
		cin >> n;
		
		if (n == 2)
		{
			int num1, num2;
			cin >> num1 >> num2;
			
			cout << (LL)num1 * num2 << endl;
		}
		else
		{
			int cnt1 = 0, cnt2 = 0;
			
			for (int i = 0; i < n; i ++)
			{
				int x;
				cin >> x;
			
				if (x >= 0)
					a[cnt1 ++] = x;
				else
					b[cnt2 ++] = x;
			}
		
			sort(a, a + cnt1);
			sort(b, b + cnt2);
			
			LL res;
			if (cnt1 >= 2 && cnt2 >= 2)
			{
				res = max((LL)b[0] * b[1], (LL)a[cnt1 - 2] * a[cnt1 - 1]);
			}
			else if (cnt1 >= 2 && cnt2 < 2)
				res = (LL)a[cnt1 - 2] * a[cnt1 - 1];
			else if (cnt1 < 2 && cnt2 >= 2)
				res = (LL)b[0] * b[1];
			
			cout << res << endl;
		}
	}
	
    return 0;
}

C. Bun Lover

分析:

找规律,发现结果与边长n的关系是:res = n * (n + 3) - (n - 2)

code:

#include <bits/stdc++.h>
using namespace std;
 
const int N = 2e5 + 5;
int a[N], b[N];
 
typedef long long LL;
 
int main()
{
    std::ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
	
	int t;
	cin >> t;
	
	while (t --)
	{
		LL n;
		cin >> n;
		
		cout << n * (n + 3) - (n - 2) << endl;
	}
	
    return 0;
}

D. Super-Permutation

分析:

①当n为奇数时,除了1其他均无解
②当n为偶数时,我们可以构造一个形如n,1,n - 2,3,...的数列
首先我们可以发现n必定出现在起始位置。如果n不在起始位置,假设在位置i,那么s[i - 1] % n == (s[i - 1] + n) % n = s[i] % n。
接着,考虑构造方式。最方便的即是考虑让序列取模结果为:0,1,-1,2,-2...(-1取模意义下溢出实际上就是n - 1),按上述结果形式构造的序列n,1,n - 2,3,...即可满足所有条件
最后从结果来看就是n在偶数位递减,1在奇数位递增。

code:

#include <bits/stdc++.h>
using namespace std;
 
const int N = 2e5 + 5;
int a[N];
 
int main()
{
	std::ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	
	int t;
	cin >> t;
	
	while (t --)
	{
		int n;
		cin >> n;
		
		if (n == 1)
			cout << 1 << endl;
		else if (n & 1)
			cout << -1 << endl;
		else
		{
			for (int i = 0, j = n; i < n; i += 2, j -= 2)
				a[i] = j;
			for (int i = 1, j = 1; i < n; i += 2, j += 2)
				a[i] = j;
			for (int i = 0; i < n; i ++)
				cout << a[i] << " ";
			cout << endl;
		}
	}
	
	return 0;
}

E. Making Anti-Palindromes

分析:

①当n为奇数时:根据定义无解。
②当n为偶数时:
当某个字符出现的次数大于n / 2时,根据容斥原理,一定存在s[i] = s[n - i + 1]。
若不存在上述情况则一定有解,考虑如何处理对称字符:倘若存在形如..a..b..b..a的字符对我们优先选择交换a和b,这样一次操作可以处理两对字符,否则将对称对形如..a..b..d..a的情况交换a和d,一次操作处理一对字符。统计出现次数最多的字符对,其出现次数记为cnt1,所有字符对总数量记为cnt2,优先处理cnt1,所以当cnt1 <= cnt2 - cnt1时,答案即cnt2 / 2,否则答案即cnt1

code:

#include <bits/stdc++.h>
using namespace std;
 
const int N = 27;
int h[N], h2[N];
 
int main()
{
	std::ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	
	int t;
	cin >> t;
	
	while (t --)
	{
		int n;
		cin >> n;
		string s;
		cin >> s;
		
		if (n & 1)
			cout << -1 << endl;
		else
		{
			bool check = true;
			memset(h2, 0, sizeof h2);
			memset(h, 0, sizeof h);
			
			for (int i = 0; i < n; i ++)
			{
				h2[s[i] - 'a'] ++;
				if (h2[s[i] - 'a'] > n / 2)
				{
					check = false;
					break;
				}
			}
			
			
			if (check)
			{
				int Max = 0, cnt = 0;
				for (int i = 0, j = n - 1; i < n / 2; i ++, j --)
				{
					if (s[i] == s[j])
					{
						h[s[i] - 'a'] ++;
						Max = max(Max, h[s[i] - 'a']);
						cnt ++;
					}
				}
				
				if (Max <= cnt - Max)
					cout << (cnt + 1) / 2 << endl;
				else
					cout << Max << endl;
			}
			else
				cout << -1 << endl;
		}
	}
	
	return 0;
}

标签:std,cout,int,Codeforces,867,cin,cnt1,tie,Div
From: https://www.cnblogs.com/XiongTingyang/p/17372897.html

相关文章

  • Codeforces 908H - New Year and Boolean Bridges(FWT)
    一道挺有意思的题,并且感觉有点诈骗的成分在内(首先考虑分析三种字符的性质:显然任意两点\(i,j\)之间要么\(i\)可以到达\(j\),要么\(j\)可以到达\(i\),否则AOX三个一个都不能满足。如果两点间的状态是A,那么这两点必须在同一强连通分量内。如果两点间的状态是X,那么这......
  • 4.[1201D - Treasure Hunting](https://codeforces.com/problemset/problem/1201/D)
    4.1201D-TreasureHunting题目意思:在一个n*m的地图上面,左下角的坐标是(1,1),最开始你位于左下角,一秒钟你可以进行往左或者往右的操作,你只能在一些特殊的列上面进行往上移动的操作,你不可以往下移动。现在告诉你k个宝藏的坐标信息以及哪些列是允许往上的,问最后至少要几秒可以遍历k......
  • Deltix Round, Spring 2021 (open for everyone, rated, Div. 1 + Div. 2)
    好久没发博客了,发一篇。A求出每个\(0\)与往前/往后最近的\(1\)的距离即可。时间复杂度\(\mathcal{O}(n)\)。B\((x,y)\to(x+y,y)\to(x+y,-x)\to(y,-x)\to(y-x,-x)\to(y-x,-y)\to(-x,-y)\)。时间复杂度\(\mathcal{O}(n)\)。C开个栈模拟......
  • CF1190 div.1板刷记
    经过上一次的vp,发现自己还有很大不足,所以还在板刷div.1。ACF题面模拟即可。点击查看代码#include<bits/stdc++.h>#defineullunsignedlonglong#defineintlonglong#definepiipair<int,int>#definepbpush_back#definempmake_pairusingnamespacestd;names......
  • Codeforces Round 869 (Div. 2) A-D题解
    比赛地址A.Politics题意:有n个人对m个决案进行投票,对于每一个决案如果票数相同则所有人都离场,反之票数少的一方离场,现在提前知道了每个人的意见,让一些人参与投票,在保证第一个人不离场的情况下最终剩余人数最多是多少Solution把和第一个意见不同的给去掉就行了voidsolve(){......
  • CF1416 Div.1 VP记
    好久没打CF了,感觉写代码能力有所下降,vp一场看看,差点被阻击没了。ACF题面先考虑将某一个数字提出来,可以发现如果这个数字要对答案造成贡献,那么\(k\)最小为没有该数字的区间中最长的区间长度加一。点击查看代码#include<bits/stdc++.h>#defineullunsignedlonglong#def......
  • Chemistry Experiment Codeforces Round 247 (Div. 2) 线段树动态开点,二分
    第一次写的时候还不会线段树的动态开点,写了一个是线段树但是是\(O(N^2)\)的写法,现在用动态开点武装了自己,会了正解\(O(qlogn^2)\)。首先建立一个权值线段树,但这里的权值很大,通过动态开点去建树来节省空间,对于两种操作:操作1,常见的动态开点的单点修改操作2,二分答案,然后在线段树......
  • Codeforces 280C Game on Tree
    设\(p_i\)为\(i\)涂色或不涂色,\(1\)为涂,\(0\)为不涂,答案即为\(E[\sum_{i=1}^np_i]\)然后转化一下柿子:\(\sum_{i=1}^nE[p_i]\),这就很好求了,单独求每个点\(E[p_i]\)的值就行了考虑对于\(u\)点,\(p_u=1\),即能被涂需要满足其祖先都比其晚涂色假设现在有一个序列里面......
  • Educational Codeforces Round 147 (Rated for Div. 2) 题解
    ALink。模拟,代码。BLink。模拟,代码。CLink。我们设\(c\)为最后相同的字符。性质:我们一定不会删除字符\(c\)。因此以\(c\)为最后字符的操作次数就是不包含字符\(c\)的极大段的最小操作次数的最大值。对于一个长度为\(l(l\ge1)\)的段,它的最小操作次数为\(\l......
  • 【Introductory Biology】Lecture 12 - Chemical Genetics 1 - Cell Division & Segre
    文章目录SlidesRefSlidescentraldogma中心法则…Andwe’regoingtostarttalkingabouthowinformationflowsbetweencells,sofromaparentcelltoitsdaughtercells.Andwe’realsogonnatalkabouthowinformationflowsfromgenerationtothenext.Andth......